// *************************************************************************
//    BuiltinSymbols.h
// *************************************************************************

#ifndef _BuiltinSymbols_H_
#define _BuiltinSymbols_H_

#include "SymbolArg.h"

// *************************************************************************

#ifndef DeclareKeyword
#define DeclareKeyword(x,s) extern corSymbol *x;
#endif

// *************************************************************************

DeclareKeyword(corConsSymbol,     "cons")
DeclareKeyword(corListSymbol,     "_LIST_")
DeclareKeyword(corNestedSymbol,   "__NESTED__")
DeclareKeyword(corNilSymbol,      "nil")
DeclareKeyword(corTrueSymbol,     "true")
DeclareKeyword(corModuleSymbol,   "module")
DeclareKeyword(corExportSymbol,   "export")
DeclareKeyword(corQSymbol,        "q")
DeclareKeyword(corQuerySymbol,    "query")
DeclareKeyword(corDontCareSymbol, "_")
DeclareKeyword(corCutSymbol,      "cut_")

// Arithmetic operations
DeclareKeyword(corAddOpSymbol,    "add_")
DeclareKeyword(corSubOpSymbol,    "sub_")
DeclareKeyword(corMulOpSymbol,    "mul_")
DeclareKeyword(corDivOpSymbol,    "div_")
DeclareKeyword(corIDivOpSymbol,   "idiv_")
DeclareKeyword(corEquOpSymbol,    "equ_")
DeclareKeyword(corNeqOpSymbol,    "neq_")
DeclareKeyword(corLssOpSymbol,    "lss_")
DeclareKeyword(corGrtOpSymbol,    "grt_")
DeclareKeyword(corLeqOpSymbol,    "leq_")
DeclareKeyword(corGeqOpSymbol,    "geq_")
DeclareKeyword(corCopyTermSymbol, "copy_term")

// Head aggregate operators
DeclareKeyword(corSumOpSymbol,    "sum")
DeclareKeyword(corProdOpSymbol,   "prod")
DeclareKeyword(corCountOpSymbol,  "count")
DeclareKeyword(corMinOpSymbol,    "min")
DeclareKeyword(corMaxOpSymbol,    "max")
DeclareKeyword(corAvgOpSymbol,    "avg")
DeclareKeyword(corADstOpSymbol,   "avg_distinct")
DeclareKeyword(corSDstOpSymbol,   "sum_distinct")
DeclareKeyword(corPDstOpSymbol,   "prod_distinct")
DeclareKeyword(corCDstOpSymbol,   "count_distinct")
DeclareKeyword(corDstOpSymbol,    "distinct")

DeclareKeyword(corAbsOpSymbol,    "abs")
DeclareKeyword(corCeilOpSymbol,   "ceiling")
DeclareKeyword(corFloorOpSymbol,  "floor")
DeclareKeyword(corAnyOpSymbol,    "any")

// bitwise operator builtins
DeclareKeyword(corLShiftOpSymbol, "lshift_")  //  <<
DeclareKeyword(corRShiftOpSymbol, "rshift_")  //  >>
DeclareKeyword(corBitorOpSymbol,  "bitor_")   //  bitor
DeclareKeyword(corBitandOpSymbol, "bitand_")  //  bitand
DeclareKeyword(corBitnotOpSymbol, "bitnot_")  //  bitnot
DeclareKeyword(corBitxorOpSymbol, "bitxor_")  //  bitxor
DeclareKeyword(corCompOpSymbol,   "comp_")    //  ~
DeclareKeyword(corModOpSymbol,    "mod_")     //  %

// set manipulation builtins
DeclareKeyword(corAddElemSymbol,  "add_elem")
DeclareKeyword(corAddElemDSymbol, "add_elem_d")
DeclareKeyword(corCallSymbol,     "call")
DeclareKeyword(corCreateSetSymbol, "create_set")
//DeclareKeyword(MsetOpSymbol, "makeset")
DeclareKeyword(corMemberSymbol,   "member")
DeclareKeyword(corMemTupleSymbol, "memtuple")
DeclareKeyword(corSubsetSymbol,   "subset")
DeclareKeyword(corUnionSumSymbol, "unionsum")
DeclareKeyword(corUnionMaxSymbol, "unionmax")
DeclareKeyword(corUnionSumDSymbol, "unionsum_d")
DeclareKeyword(corUnionMaxDSymbol, "unionmax_d")
DeclareKeyword(corUnivSymbol,     "univ")
DeclareKeyword(corInterSymbol,    "inter")
DeclareKeyword(corDifferenceSymbol, "difference")
DeclareKeyword(corMakeSetSymbol,  "make_set")
DeclareKeyword(corInterDSymbol,   "inter_d")
DeclareKeyword(corDifferenceDSymbol, "difference_d")
DeclareKeyword(corMakeSetDSymbol, "make_set_d")


DeclareKeyword(corFunctorSymbol, "functor")
DeclareKeyword(corArgSymbol,     "arg")
DeclareKeyword(corPowSymbol,     "pow")


// string manipulation builtins
DeclareKeyword(corLengthSymbol, "length")
DeclareKeyword(corExtractSymbol, "extract")
DeclareKeyword(corSubstringSymbol, "substr")


// User annotations
DeclareKeyword(corSupplementaryMagicSymbol, "sup_magic") 
DeclareKeyword(corOrdinaryMagicSymbol, "magic") 
DeclareKeyword(corNoMagicSymbol, "no_form_of_magic") 
DeclareKeyword(corSupMagicIndexingSymbol, "sup_magic_indexing") 
DeclareKeyword(corExistOptSymbol, "existential")
DeclareKeyword(corUseFactoringSymbol, "factoring")
DeclareKeyword(corUseFactorMagicSymbol, "factor_magic")
DeclareKeyword(corUsePipeliningSymbol, "pipelining")
DeclareKeyword(corUseOrdSearchSymbol, "ordered_search")
DeclareKeyword(corSaveModuleSymbol, "save_module") 
DeclareKeyword(corNoRewritingSymbol, "no_rewriting")
DeclareKeyword(corNoPreProcessingSymbol, "no_preprocessing")

DeclareKeyword(corNestedSccEvalSymbol, "nested_scc_eval")  // added by Ken

DeclareKeyword(corSingleSccSymbol, "single_scc")
DeclareKeyword(corSingleAnswerSymbol, "single_answer")
DeclareKeyword(corConvertFunctionsSymbol, "convert_functions")
DeclareKeyword(corPredicateSNSymbol, "psn") 

DeclareKeyword(corMultisetSymbol, "multiset") 
DeclareKeyword(corCheckSubsumSymbol, "check_subsumption") 
DeclareKeyword(corAggSelectionSymbol, "aggregate_selection")
DeclareKeyword(corPrioritizeSymbol, "prioritize")
DeclareKeyword(corChoiceSymbol, "choice")
DeclareKeyword(corDiskResidentSymbol, "disk")

DeclareKeyword(corIndexDeltaSymbol,"index_deltas") 
DeclareKeyword(corReturnUnifySymbol,"return_unify") 
DeclareKeyword(corEagerEvalSymbol, "lazy_eval")
DeclareKeyword(corMonotonicSymbol, "monotonic")
DeclareKeyword(corMakeIndexSymbol, "make_index")
DeclareKeyword(corAllowedAdornSymbol, "allowed_adornments")
DeclareKeyword(corAllowedIndexSymbol, "allowed_index_args")
DeclareKeyword(corNonGroundFactsSymbol, "non_ground_facts")
DeclareKeyword(corSipReorderSymbol, "sip_reorder")
DeclareKeyword(corEagerIndexingSymbol, "eager_indexing")

// Print builtins
DeclareKeyword(corPrintEmptySymbol, "print_empty")
DeclareKeyword(corPrintBindingSymbol, "print_bindings")
DeclareKeyword(corPrintTupleSymbol, "print_tuple")
DeclareKeyword(corDisplaySymbol,"print")
DeclareKeyword(corPrintfSymbol,"printf")
DeclareKeyword(corScanfSymbol, "scanf")
DeclareKeyword(corPrintModSymbol, "print_module")

// Builtin relations
DeclareKeyword(corAliasSymbol, "alias_rel")
DeclareKeyword(corAssignSymbol,"assign")
DeclareKeyword(corClearSymbol, "clear")
DeclareKeyword(corConsultSymbol,"consult") 
DeclareKeyword(corCpuTimeSymbol, "cputime")
DeclareKeyword(corDeleteFactSymbol, "delete")
DeclareKeyword(corDisplayTimerSymbol, "display_timer")
DeclareKeyword(corExplainOffSymbol, "explain_off")
DeclareKeyword(corExplainOnSymbol, "explain_on")
DeclareKeyword(corFailSymbol,"fail") 
DeclareKeyword(corGetSymbol,   "get")
DeclareKeyword(corGoalIdOpSymbol,"goal_id") 
DeclareKeyword(corHelpSymbol,"help")
DeclareKeyword(corHistorySymbol, "history")
DeclareKeyword(corInsertFactSymbol, "insert")
DeclareKeyword(corPipeInSymbol,"pipein") 
DeclareKeyword(corPipeOutSymbol,"pipeout") 
DeclareKeyword(corProfileOffSymbol, "profile_off")
DeclareKeyword(corProfileOnSymbol, "profile_on")
DeclareKeyword(corQuitSymbol,"quit") 
DeclareKeyword(corStartTimerSymbol, "reset_timer")
DeclareKeyword(corSetSymbol,   "set")
DeclareKeyword(corBreakSymbol, "set_break")
DeclareKeyword(corClearBreakSymbol, "clear_break")
DeclareKeyword(corShellSymbol, "shell")
DeclareKeyword(corTraceSymbol, "trace_on")
DeclareKeyword(corUntraceSymbol, "trace_off")
DeclareKeyword(corWriteTableSymbol, "write_table")
extern char *corArrayConstructorString;
DeclareKeyword(corArrayConstructSymbol, corArrayConstructorString)

// Builtin relations for suspensions and client/server operation
DeclareKeyword(corAnswerSymbol, "answer")
DeclareKeyword(corKillSymbol, "kill")
DeclareKeyword(corListSusSymbol, "list_sus")
DeclareKeyword(corLoginSymbol, "login")
DeclareKeyword(corLogoutSymbol, "logout")
DeclareKeyword(corResumeSymbol, "resume")
DeclareKeyword(corSocketRelSymbol, "socket_rel")
DeclareKeyword(corSyncSymbol, "sync")
DeclareKeyword(corUserSymbol, "user")
DeclareKeyword(corWhoSymbol, "who")
DeclareKeyword(corWhoamiSymbol, "whoami")
DeclareKeyword(corYieldSymbol, "yield")

// Counter Stuff
DeclareKeyword(corCounterSymbol, "c_counter")
DeclareKeyword(corResetCounterSymbol, "reset_c_counter")

// Builtin relations to deal with multiple workspaces( nee\ databases)
DeclareKeyword(corCreateDBSymbol, "ws_create")
DeclareKeyword(corDestroyDBSymbol, "ws_destroy")
DeclareKeyword(corCurrentDBSymbol, "ws_current")
DeclareKeyword(corSaveDBSymbol, "ws_save")
DeclareKeyword(corRenameDBSymbol, "ws_rename")
DeclareKeyword(corClearDBSymbol, "ws_clear")
DeclareKeyword(corCopyRelToDBSymbol, "rel_copy")
DeclareKeyword(corAddRelToDBSymbol, "rel_add")
DeclareKeyword(corClearRelSymbol, "rel_clear")
DeclareKeyword(corCloseRelSymbol, "rel_close")
DeclareKeyword(corListRelsInDBSymbol, "list_rels")
DeclareKeyword(corListDBSymbol, "list_ws")
DeclareKeyword(corOpenRelInDBSymbol, "rel_open")

// Builtin relations to handle the default execution environment
DeclareKeyword(corDisplayDefaultsSymbol, "display_defaults")
DeclareKeyword(corResetDefaultsSymbol, "reset_defaults")

// Builtin relations to check the type of an arg
DeclareKeyword(corIsConstantSymbol, "is_constant")
DeclareKeyword(corIsVarSymbol, "is_var")
DeclareKeyword(corIsListSymbol, "is_list")
DeclareKeyword(corIsFunctorSymbol, "is_functor")
DeclareKeyword(corIsStringSymbol, "is_string")
DeclareKeyword(corIsNumSymbol, "is_num")
DeclareKeyword(corIsIntSymbol, "is_int")
DeclareKeyword(corIsLongSymbol, "is_long")
DeclareKeyword(corIsShortSymbol, "is_short")
DeclareKeyword(corIsFloatSymbol, "is_float")
DeclareKeyword(corIsDoubleSymbol, "is_double")

// *************************************************************************

void corinit_builtin_symbols();

// *************************************************************************

#endif _BuiltinSymbols_H_

