/*****************************************************************************/
//    Catalog.h
/*****************************************************************************/

#ifndef _Catalog_H_
#define _Catalog_H_

/*****************************************************************************/

class corCatalog {
private:
    FID cat_fid;
    IID cat_iid;

public:
    // Check if a file is in the catalog
    int lookupFile(char *name, OID * oid);

    // Add a file to the catalog, and returns the FileDesc structure in obj
    int addFile(char *file_name, corFileDescStruct *obj);

    // Delete a file from the catalog index
    int deleteFile(char *file_name, OID *oid);

    // Initialize catalog
    int init(char *cat_file_name, char *cat_index_name);

    // List all files
    void listFiles(FILE *outf);
};

/*****************************************************************************/

#endif _Catalog_H_

