/*****************************************************************************/
//	ExprArg.h
/*****************************************************************************/

#ifndef _ExprArg_H_
#define _ExprArg_H_

#include "NumArg.h"
#include "SymbolArg.h"
#include "CArg.h"

/*****************************************************************************/
struct corExprArg : public corNumArg {
	Name op;
	int op_arity;
	corCArg left_arg;
	corCArg right_arg;

	corExprArg(Name op, corArg* left, corArg* right) 
	 {this->op = op; 
	  left_arg = left; right_arg = right; 
	  op_arity = 2; 
	  _num_kindof = COR_ARITH_EXPR;
	 }

	corExprArg(Name op, corArg *only)
	 {this->op = op; left_arg = only; 
	  right_arg = 0; op_arity = 1;
	  _num_kindof = COR_ARITH_EXPR;}

	corExprArg(Name op, corCArg left, corCArg right) 
	 {this->op = op; 
	  left_arg = left; right_arg = right; 
	  op_arity = 2; _num_kindof = COR_ARITH_EXPR;
	 }

	corExprArg(Name op, corCArg only)
	 {this->op = op; 
	  left_arg = only; right_arg = 0;
	  op_arity = 1;
	  _num_kindof = COR_ARITH_EXPR;
	 }

	corExprArg(Name op, corCArg* left, corCArg* right) 
	 {this->op = op; 
	  left_arg = *left; right_arg = *right;
	  op_arity = 2; _num_kindof = COR_ARITH_EXPR;
	 }

	corExprArg(Name op, corCArg* only)
	 {this->op = op; 
	  left_arg = *only; right_arg = 0;
	  op_arity = 1;
	  delete only;
	  _num_kindof = COR_ARITH_EXPR;
	 }

	virtual ~corExprArg() {}

	virtual corCArg simplify(corBindEnv *context, corTermLink *&renamed_vars,
			corBindEnv *const_env, corBindEnv *rename_only_env);

	virtual HashVal hash(corBindEnv *context = 0);
	virtual corVarLink *var_list(corVarLink* rest);

	virtual void print(corBindEnv *, FILE *) const ;
	virtual void print_dump(corBindEnv * env, FILE *file) const;
	virtual void printon(FILE *) const ;
	virtual void printon(FILE *, char *) const ; 
	virtual void sprint(char *str, int *pos, corBindEnv*context = NULL) const;
       };

/*****************************************************************************/

#endif _ExprArg_H_

