//*********************************************************************
//    Globals.h
//*********************************************************************

#ifndef _Globals_H_
#define _Globals_H_

#include "ExecutionEnv.h"
#include "ParserStruct.h"
#include "ParserEnv.h"
#include "TableStack.h"
#include "CoralConfig.h"
#include "ParseStack.h"
#include "Trail.h"
#include "ConnectArray.h"

//*********************************************************************
// This class does _almost_ nothing, it is around to clear out the
// Symbol table after all the other destructors have finished and
// the program is exiting.  Thus its main purpose is to minimize the
// output of "purify" to allow real memory leaks to be more apparent.

extern void corclearSymbols();

class corClearSym {

    int clear;    // Should we clear the symbol table? 

  public:
    clear_at_end(){ clear = 1; }
    corClearSym(){ clear = 0; }
   ~corClearSym(){ if (clear) corclearSymbols(); }
};

//*********************************************************************
// See Globals.C for explanations of these things.
//*********************************************************************

extern corTrail        *corCurTrail;

extern corExecutionEnv  cordeflt_exEnv;
extern corExecutionEnv *corexEnv;

extern corParserStruct  corparserStruct;
extern CoralConfig   coralConfig;

extern corParseStack   *corparseStack;
extern corParserEnv    *corparseEnv;

extern corUser         *corcurUser;
extern corConnection   *corcurConn;
extern corConnectArray  cordeflt_conn;
extern corConnectArray *corclients;

extern corClearSym      corclearSym;

//*********************************************************************

extern char coral_pid[32];        // Process Id of this coral program

//*********************************************************************

#endif _Globals_H_
