/*****************************************************************************/
//    HashIndexSet.h
/*****************************************************************************/

#ifndef _HashIndexSet_H_
#define _HashIndexSet_H_

#include "GenericIndexSet.h"
#include "HashIndex.h"

/*****************************************************************************/

class corHashIndexSet : public corGenericIndexSet {
protected:
    int find_exact( corHashIndex *index);

public: 
    corHashIndexSet(corStorageRelation* rel) : corGenericIndexSet(rel) {}

    virtual corGenericIndex *find_index( corTupleIterator& iterator) {
        return find_index(iterator.arg_list, iterator.bindenv,
            iterator.indexnump);
    }
    virtual corGenericIndex *find_index( corTuple* tuple, int *tryindexp = NULL) {
        return find_index(*(tuple->_args), tuple->bindenv, tryindexp);
    }
    virtual corGenericIndex *find_index(corArgList&,corBindEnv*,int *tryindexp = NULL);
    int insert_index(corGenericIndex*);
    void fill_index(corGenericIndex*);
    virtual int add_all_tuples(corStorageRelation *reln,
        int marks_into_account = 0, int check_dupl = 0, int hide_em = 0);
    virtual int add_all_goals(corStorageRelation *_reln, corContext *_context,
        corStorageRelation *owner_rel);
    int move_all_entries(corStorageRelation *reln);
};

/*****************************************************************************/

#endif _HashIndexSet_H_

