// *************************************************************************
//    QFMaterializedModuleData.h
// *************************************************************************

#ifndef _QFMaterializedModuleData_H_
#define _QFMaterializedModuleData_H_

#include "QFModuleData.h"
#include "Table.h"
#include "RuleInfoArray.h"
#include "ParserStruct.h"
#include "Scc.h"
#include "Predicate.h"
#include "TupleIterator.h"
#include "SccInfo.h"

// *************************************************************************

//class SccInfo;

// *************************************************************************

class corQFMaterializedModuleData : public corQFModuleData {
public:
    int numSccs;
    corSccInfo** sccArray;                // Array of Sccs to evaluate in order
    int use_psn;                    // Should the module use PSN or not

    // The following two fields are for the use of SaveModules
    // The first field "saved_state" distinguishes between the first 
    // call to a Savemodule and subsequent calls.
    // If the second field "no_magic" is set, only one call to Solve
    // needs to be made since the first call will completely evaluate
    // the save module.

    int saved_state;                // has the state been saved already?
    int no_magic;

    corQFMaterializedModuleData(corTable *table, corRuleInfoArray *rArray,
        corParserStruct&);
    ~corQFMaterializedModuleData();
    void AddScc(corScc *scc, corPredicate *ext_magicpred);
    virtual void Solve(corTable *F, corTupleIterator *iterator = NULL);
    void clean_cache();
    virtual ModuleKind kindof()        { return COR_MATERIALIZED; };
    void print(FILE *fd, int print_preds = 1, 
         int print_text = 1, int print_snrules = 1); // added by Ken
};

// *************************************************************************

#endif _QFMaterializedModuleData_H_

