// *************************************************************************
//    Table.h
// *************************************************************************

#ifndef _Table_H_
#define _Table_H_

#include "RelationStruct.h"
#include "ModuleEnv.h"
#include "Context.h"
//#include "QFModuleData.h"

// *************************************************************************

class corQFModuleData;

// *************************************************************************

struct corTable {
public:
    int numRels;
    corRelationStruct *rels;

    corModuleEnv *module_env;      // dynamic data structures used
                                // for module execution

    int interrupt_flag;         // used by cut and single answer to interrupt
                                // execution of the current module  

    corContext *context;           // the stack for ordered search
    corQFModuleData *moduledata;   // data about module 

    corTable *next;                // Keeps a list of free initialized table
                                // structs that can be reused.

    corTable(int num_rels) {
        rels=new corRelationStruct[num_rels];
        numRels=num_rels;
        context = NULL;
        module_env = NULL;
    }
    corTable(corQFModuleData *md);
   ~corTable();
    void AddValue(int i, Name relName, int arity);
};

// *************************************************************************

#endif _Table_H_

