/*****************************************************************************/
//	VarArg.h
/*****************************************************************************/

#ifndef _VarArg_H_
#define _VarArg_H_

#include "Arg.h"
#include "SymbolArg.h"
#include "BindEnv.h"
#include "CArg.h"

/*****************************************************************************/
// Use for making linked lists of Vars.

struct corVarLink { 
	corVarLink *next;
	corVarArg *arg;
	corVarLink(corVarArg *a, corVarLink *n) { arg = a; next = n; }
	int contains(corVarArg *a);
};

/*****************************************************************************/

struct corVarArg : public corArg {
	Name	 _functor;	   /* name of variable */
	int	 var;		/* Index into current context */
	inline corVarArg(Name name, int index) {
	  _functor = name; var = index; 
	  _kindof = COR_VARIABLE;}

	inline corVarArg(corCArg* cName, int index) { 
	  _functor = cName->SymbolP(); 
	  var = index; 
	  _kindof = COR_VARIABLE;
	 }

	virtual ~corVarArg() {}

	inline Name var_name() const { return _functor; }

	virtual void print(corBindEnv*, FILE *file) const;
	virtual void print(corBindEnv*, FILE *file, char *fmt_str) const;
	virtual void sprint(char *str, int *pos, corBindEnv *context = NULL) const;

	inline corTerm dereference_var(corBindEnv* env); // Does a one level dereference
	inline corTerm dereference(corBindEnv* env);  	// Does a full dereference

	//virtual arg_kind kindof() const ;
	virtual int isConstant();
	virtual int equals(corArg *arg2);

	virtual corVarLink *var_list(corVarLink* rest);
	virtual HashVal hash(corBindEnv *context = 0);
	virtual int scan_vars(void *data, VarFunc *func);
	virtual corCArg simplify(corBindEnv *context, corTermLink *&renamed_vars,
		corBindEnv *const_env, corBindEnv *rename_only_env);
};

/*****************************************************************************/

#endif _VarArg_H_

