
# The routines in this file have borrowed generously from 
# the jedit routines by Jay Sekora
#

####################################
#
# Clear all bindings on this window
#
proc j:clear_bind {win} {

    foreach seq [bind $win] {

        bind $win $seq
    }
}

######################################################################
# j:selection_if_any - return selection if it exists, else {}
#   this is from kjx@comp.vuw.ac.nz (R. James Noble)
#   defined elsewhere, but copied here so the bindings libraries
#   don't depend on jtkutils
######################################################################

proc j:selection_if_any {} {
    if {[catch {selection get} s]} {return ""} {return $s}
}

######################################################################
####
###  GENERAL BINDING ROUTINES
####
######################################################################

######################################################################
# j:tb:init - initialize info for bindings
######################################################################

proc j:tb:init {} {
  
  # TEXT MAPS ########################################################
  
  j:tkb:mkmap Text vi-command vi-command {
    {Delete			j:tkb:left}
    {BackSpace			j:tkb:left}
    {Return			j:tkb:down}
    
    {Up				j:tkb:up}
    {Down			j:tkb:down}
    {Left			j:tkb:left}
    {Right			j:tkb:right}

    {k				j:tkb:up}
    {j				j:tkb:down}
    {h				j:tkb:left}
    {l				j:tkb:right}

    {Control-k			prev_hist}
    {Control-j			next_hist}
    {Control-h			j:tkb:left}
    {Control-l			j:tkb:right}

    {x				j:tkb:delete_right}
    {p				j:tkb:put_text_right}
    
    {i				j:tkb:vi:insert}
    {a				j:tkb:vi:append}
    {I				j:tkb:vi:insert-bol}
    {A				j:tkb:vi:append-eol}
    
    {Home			j:tkb:bol}
    {End			j:tkb:eol}
    
    {asciicircum		j:tkb:bol}
    {dollar			j:tkb:eol}
    
    {Next			j:tkb:scroll_down}
    {Prior			j:tkb:scroll_up}
    
    {Escape			j:tkb:clear_count}
    
    {1				j:tkb:continue_number}
    {2				j:tkb:continue_number}
    {3				j:tkb:continue_number}
    {4				j:tkb:continue_number}
    {5				j:tkb:continue_number}
    {6				j:tkb:continue_number}
    {7				j:tkb:continue_number}
    {8				j:tkb:continue_number}
    {9				j:tkb:continue_number}
    {0				j:tkb:continue_number}
    
    {Control-DEFAULT		j:tb:no_op}
    {DEFAULT			j:tb:no_op}
    {Shift-DEFAULT		j:tb:no_op}
  }

  j:tkb:mkmap Text vi-insert vi-insert {
    {Delete			j:tkb:delete_left}
    {BackSpace			j:tkb:delete_left}
    {Return			j:tkb:insert_newline}
    
    {Control-i			j:tkb:self_insert}
    {Control-j			j:tkb:self_insert}
    {Control-h			j:tkb:delete_left}
    
    {Escape			j:tkb:vi:command}
    
    {Control-u			j:tkb:kill_line}
    {Control-v			j:tkb:new_mode vi-literal}
    
    {Control-DEFAULT		j:tb:no_op}
    {DEFAULT			j:tkb:self_insert}
    {Shift-DEFAULT		j:tkb:self_insert}
  }
  
  j:tkb:mkmap Text vi-literal vi-insert {
    {DEFAULT			j:tkb:self_insert}
    {Shift-DEFAULT		j:tkb:self_insert}
    {Control-DEFAULT		j:tkb:self_insert}
    {Meta-DEFAULT		j:tkb:self_insert}
  }
  
  j:tkb:mkmap Text emacs-normal emacs-normal {
    {Delete			j:tkb:delete_left}
    {BackSpace			j:tkb:delete_left}
    {Return			j:tkb:insert_newline}
    
    {Control-d			j:tkb:delete_right}
    
    {Up				j:tkb:up}
    {Down			j:tkb:down}
    {Left			j:tkb:left}
    {Right			j:tkb:right}
    
    {Control-p			j:tkb:up}
    {Control-n			j:tkb:down}
    {Control-b			j:tkb:left}
    {Control-f			j:tkb:right}
    
    {Home			j:tkb:bol}
    {End			j:tkb:eol}
    
    {Control-a			j:tkb:bol}
    {Control-e			j:tkb:eol}
    
    {Next			j:tkb:scroll_down}
    {Prior			j:tkb:scroll_up}
    
    {Control-v			j:tkb:scroll_down}
    
    {Control-k			j:tkb:e:kill_line}
    {Control-w			j:tkb:e:kill_region}
    {Control-y			j:tkb:e:yank}

    {Control-i			j:tkb:self_insert}
    {Control-j			j:tkb:self_insert}
    {Control-h			j:tkb:delete_left}
    
    {Control-space		j:tkb:e:set_mark_command}
    {Control-at			j:tkb:e:set_mark_command}
    
    {Control-g			j:tkb:clear_count}
    
    {1				j:tkb:self_insert_digit}
    {2				j:tkb:self_insert_digit}
    {3				j:tkb:self_insert_digit}
    {4				j:tkb:self_insert_digit}
    {5				j:tkb:self_insert_digit}
    {6				j:tkb:self_insert_digit}
    {7				j:tkb:self_insert_digit}
    {8				j:tkb:self_insert_digit}
    {9				j:tkb:self_insert_digit}
    {0				j:tkb:self_insert_digit}
    
    {Control-u			j:tkb:e:generic_arg}
    
    {Control-q			j:tkb:new_mode emacs-literal}
    {Control-x			j:tkb:new_mode emacs-control-x}
    {Escape			j:tkb:new_mode emacs-escape}
    
    {Control-DEFAULT		j:tb:no_op}
    {DEFAULT			j:tkb:self_insert}
    {Shift-DEFAULT		j:tkb:self_insert}
  }
  
  j:tkb:mkmap Text emacs-literal emacs-normal {
    {DEFAULT			j:tkb:self_insert}
    {Shift-DEFAULT		j:tkb:self_insert}
    {Control-DEFAULT		j:tkb:self_insert}
    {Meta-DEFAULT		j:tkb:self_insert}
  }
  
  j:tkb:mkmap Text emacs-control-x emacs-normal {
    {Control-g			j:tkb:clear_count}
    {Control-x			j:tkb:e:exchange_point_and_mark}
    
    {DEFAULT			j:tkb:clear_count}
    {Shift-DEFAULT		j:tkb:clear_count}
    {Control-DEFAULT		j:tkb:clear_count}
    {Meta-DEFAULT		j:tkb:clear_count}
  }
  
  j:tkb:mkmap Text emacs-escape emacs-normal {
    {less			j:tkb:bof}
    {greater			j:tkb:eof}
    {b				j:tkb:word_left}
    {f				j:tkb:word_right}
    {v				j:tkb:scroll_up}
    {Delete			j:tkb:delete_left_word}
    {BackSpace			j:tkb:delete_left_word}
    {d				j:tkb:delete_right_word}
    
    {1				j:tkb:start_number}
    {2    			j:tkb:start_number}
    {3    			j:tkb:start_number}
    {4    			j:tkb:start_number}
    {5    			j:tkb:start_number}
    {6    			j:tkb:start_number}
    {7    			j:tkb:start_number}
    {8    			j:tkb:start_number}
    {9    			j:tkb:start_number}
    {0    			j:tkb:start_number}
    
    {Control-g			j:tkb:clear_count}
    
    {DEFAULT			j:tb:no_op}
    {Shift-DEFAULT		j:tb:no_op}
    {Control-DEFAULT		j:tb:no_op}
    {Meta-DEFAULT		j:tb:no_op}
  }
}

######################################################################
### INSERTION WITH TAGS
######################################################################

######################################################################
# j:tb:insert_string w text - insert text into w at insert,
#   possibly honouring current tag list for widget
######################################################################

proc j:tb:insert_string { w text } {
  global j_teb
  global j_tag
  
  if [info exists j_tag(tags,$w)] {		;# using tagged text
    j:tag:insert_string $w $text
  } else {
    set start [$w index insert]
    $w insert insert $text
    $w yview -pickplace insert
  }
  set j_teb(modified,$w) 1
}

######################################################################
# j:tb:no_op - do nothing
######################################################################

proc j:tb:no_op { args } {
  return 0
}

######################################################################
# j:tb:mark_dirty W - mark widget W as dirty (modified)
######################################################################

proc j:tb:mark_dirty { W } {
  global j_teb
  set j_teb(modified,$W) 1
}

######################################################################
# j:tb:mark_clean W - mark widget W as clean (unmodified)
######################################################################

proc j:tb:mark_clean { W } {
  global j_teb
  set j_teb(modified,$W) 0
}

######################################################################
# j:tb:is_dirty W - return 1 if W is dirty (modified) else 0
######################################################################

proc j:tb:is_dirty { W } {
  global j_teb
  return $j_teb(modified,$W)
}

######################################################################
######################################################################
# ROUTINES TO SET UP TEXT BINDINGS
######################################################################
######################################################################

# j:tb:key_bind W - set up bindings to process keys
proc j:tb:key_bind { W args } {
  # get rid of a few default Tk bindings:
  foreach binding {
    <Control-Key-v> <Control-Key-d> <Control-Key-h> <Any-Key>
    <Key-Delete> <Key-BackSpace> <Key-Return>
  } {
    bind $W $binding {}
  }
  # and create null bindings for modifiers, so they don't trigger commands:
  foreach binding {
    <Shift_L> <Shift_R> <Control_L> <Control_R> <Caps_Lock>
    <Shift_Lock> <Meta_L> <Meta_R> <Alt_L> <Alt_R>
  } {
    bind $W $binding { }
  }
  bind $W <Key>			{j:tkb:process_key %W "" %K %A}
  bind $W <Shift-Key>		{j:tkb:process_key %W "" %K %A}
  bind $W <Control-Key>		{j:tkb:process_key %W Control %K %A}
}

proc j:tb:vi_bind { W } {
  global j_teb
  set j_teb(keymap,$W) vi-insert
  set j_teb(cutbuffer,$W) {}

  j:tb:key_bind $W
# j:tb:mouse_bind $W
}

proc j:tb:emacs_bind { W } {
  global j_teb
  set j_teb(keymap,$W) emacs-normal
  set j_teb(cutbuffer,$W) {}
  
  j:tb:key_bind $W
# j:tb:mouse_bind $W
}
######################################################################
# j:tkb:repeatable tclcode W - execute tclcode one or more times
######################################################################

proc j:tkb:repeatable { tclcode W args } {
  global j_teb
  
  # set up prefix/repeat information if this widget hasn't been used yet
  if {! [info exists j_teb(prefix,$W)]} {
    set j_teb(prefix,$W) 0
  }
  if {! [info exists j_teb(repeat_count,$W)]} {
    set j_teb(repeat_count,$W) 1
  }

  # special-case prefix == 1 and repeat_count == 0 for Emacs ^U:
  #
  if {$j_teb(prefix,$W) == 1 && $j_teb(repeat_count,$W) == 0} {
    set j_teb(repeat_count,$W) 4
  }
  
  set j_teb(prefix,$W) 0			;# no longer collectig digits
  for {set jri 0} {$jri < $j_teb(repeat_count,$W)} {incr jri} {
    uplevel 1 "eval [list $tclcode]"		;# variables in caller
  }
  set j_teb(repeat_count,$W) 1
}

######################################################################
# j:tkb:clear_count W - clear argument count
######################################################################

proc j:tkb:clear_count { W args } {
  global j_teb

  # set up prefix/repeat information if this widget hasn't been used yet
  if {! [info exists j_teb(prefix,$W)]} {
    set j_teb(prefix,$W) 0
  }
  if {! [info exists j_teb(repeat_count,$W)]} {
    set j_teb(prefix,$W) 1
  }

  set j_teb(repeat_count,$W) 1
  set j_teb(prefix,$W) 0
}

######################################################################
# j:tkb:start_number W K digit - start a numeric argument
#   invalid if not bound to (a sequence ending in) a digit key
######################################################################

proc j:tkb:start_number { W K digit } {
  global j_teb
  
  # set up prefix/repeat information if this widget hasn't been used yet
  if {! [info exists j_teb(prefix,$W)]} {
    set j_teb(prefix,$W) 0
  }
  if {! [info exists j_teb(repeat_count,$W)]} {
    set j_teb(prefix,$W) 1
  }

  set j_teb(prefix,$W) 1			;# collecting # prefix
  set j_teb(repeat_count,$W) [expr "$digit"]
}

######################################################################
# j:tkb:continue_number digit - continue a numeric argument
#   invalid if not bound to a digit key
######################################################################

proc j:tkb:continue_number { W K digit } {
  global j_teb
  
  # set up prefix/repeat information if this widget hasn't been used yet
  if {! [info exists j_teb(prefix,$W)]} {
    set j_teb(prefix,$W) 0
  }
  if {! [info exists j_teb(repeat_count,$W)]} {
    set j_teb(prefix,$W) 1
  }

  if {! $j_teb(prefix,$W)} {		;# (can start as well as continue)
    set j_teb(prefix,$W) 1	
    set j_teb(repeat_count,$W) 0
  }
  set j_teb(repeat_count,$W) [expr {($j_teb(repeat_count,$W)*10)+$digit}]
}
  

######################################################################
####
###  GENERAL TEXT BINDING ROUTINES
####
######################################################################

######################################################################
# j:tkb:mkmap w map next {{key command ?args?}...} - set up pseudo-binding
#   Note that key includes modifier
######################################################################

proc j:tkb:mkmap { w map next bindings } {
  global j_teb
  
  foreach list $bindings {
    set key [lindex $list 0]
    set command [lreplace $list 0 0]
    
    set j_teb(tkm,$w,$map,$key) $command
    set j_teb(tkm_next,$w,$map) $next
  }
}

######################################################################
# j:tkb:process_key W mod K A - process keystrokes
######################################################################

proc j:tkb:process_key {W mod K A} {
  global j_teb
  
  set j_teb(next_keymap,$W) ""		;# some bindings change this
 
  if {"x$mod" != "x"} {
    set K "$mod-$K"
    set default "$mod-DEFAULT"
  } else {
    set default "DEFAULT"
  }
  
  # if this widget hasn't been used before, set its keymap from default
  if {! [info exists j_teb(keymap,$W)]} {
    set j_teb(keymap,$W) $j_teb(keymap,Text)
  }
  # if no last command, set it to {}
  if {! [info exists j_teb(last_command,$W)]} {
    set j_teb(last_command,$W) {}
  }
  set map $j_teb(keymap,$W)

  if [info exists j_teb(tkm,$W,$map,$K)] {
    # specific action for this widget
    set command $j_teb(tkm,$W,$map,$K)
    eval $command [list $W $K $A]
  } else {
    if [info exists j_teb(tkm,Text,$map,$K)] {
      # specific binding for all Text widgets
      set command $j_teb(tkm,Text,$map,$K)
      eval $command [list $W $K $A]
    } else {
      if [info exists j_teb(tkm,$W,$map,$default)] {
        # default key action for this widget
        set command $j_teb(tkm,$W,$map,$default)
        eval $command [list $W $K $A]
      } else {
        # default key action for Text widgets
        set command $j_teb(tkm,Text,$map,$default)
        eval $command [list $W $K $A]
      }
    }
  }
  set j_teb(last_command,$W) $command
  
  # if a binding hasn't explicitly chosen a different keymap for the next
  #   key, switch to the default next keymap for this keymap:
  if {"x$j_teb(next_keymap,$W)" == "x"} {
    if [info exists j_teb(tkm_next,$W,$map)] {
      set j_teb(next_keymap,$W) $j_teb(tkm_next,$W,$map)
    } else {
      set j_teb(next_keymap,$W) $j_teb(tkm_next,Text,$map)
    }
  }
  set j_teb(keymap,$W) $j_teb(next_keymap,$W)
}

######################################################################
# j:tkb:new_mode mode W K A - change modes
######################################################################

proc j:tkb:new_mode { mode W K A } {
  global j_teb
  set j_teb(keymap,$W) $mode
  set j_teb(next_keymap,$W) $mode
}


######################################################################
# j:tkb:paste_selection W - insert X selection into W
######################################################################

# j:tkb:paste_selection W - insert selection into W
#  (could also be used as mouse or key binding)
proc j:tkb:paste_selection { W K A } {
  set selection [j:selection_if_any]
  
  if {[string length $selection] != 0} {
    j:tb:insert_string $W $selection
  }
}

######################################################################
###  TEXT SCROLLING COMMANDS - fragile - assume widget has a scrollbar
######################################################################
# fragile---assumes first word of yscrollcommand is name of scrollbar!
# should catch case of no yscrollcommand!
# ALSO---should handle arguments (scroll by line rather than windowful)

proc j:tkb:scroll_down { W K A } {
  global j_teb
  j:tkb:clear_count $W
  
  set yscrollcommand [lindex [$W configure -yscrollcommand] 4]
  set scrollbar [lindex $yscrollcommand 0]	;# cross fingers and hope!
  
  $W mark set insert "[lindex [$scrollbar get] 3].0"
  $W yview insert
}

proc j:tkb:scroll_up { W K A } {
  global j_teb
  j:tkb:clear_count $W
  
  set yscrollcommand [lindex [$W configure -yscrollcommand] 4]
  set scrollbar [lindex $yscrollcommand 0]	;# cross fingers and hope!

  set currentstate [$scrollbar get]
  # following is buggy if lines wrap:
  set newlinepos [expr {[lindex $currentstate 2] - [lindex $currentstate 1]}]
  $W mark set insert "$newlinepos.0-2lines"
  $W yview insert
}



######################################################################
### INSERTION COMMANDS
######################################################################

######################################################################
# j:tkb:insert_newline W K A - insert "\n" into W, clear arg flag
######################################################################

proc j:tkb:insert_newline { W K A } {
  global j_teb

  j:tkb:repeatable {
    j:tb:insert_string $W "\n"
  } $W
}

######################################################################
# j:tkb:self_insert W K A - insert A into text widget W, clear arg flag
### (was j:tb:self_insert_nondigit
######################################################################

proc j:tkb:self_insert { W K A } {
  global j_teb

  if {"$A" != ""} {
    j:tkb:repeatable {
      j:tb:insert_string $W $A
    } $W
  }
}

######################################################################
# j:tkb:self_insert_digit W K A - insert digit A into W, unless collecting arg
######################################################################

proc j:tkb:self_insert_digit { W K A } {
  global j_teb
    
  # set up prefix/repeat information if this widget hasn't been used yet
  if {! [info exists j_teb(prefix,$W)]} {
    set j_teb(prefix,$W) 0
  }

  if $j_teb(prefix,$W) {
    j:tkb:continue_number $W $K $A
    return 0
  } else {
    if {"$A" != ""} {
      j:tkb:repeatable {
        j:tb:insert_string $W $A
      } $W
    }
  }
}

######################################################################

proc clear_repeat { W } {

  global j_teb
  set j_teb(prefix,$W) 0
  set j_teb(repeat_count,$W) 1
}

######################################################################
###  TEXT MOVEMENT COMMANDS
######################################################################

# j:tkb:bol W K A - move to start of line (ignores count)
proc j:tkb:bol { W K A } {
  $W mark set insert {begin + 1 char}
  $W yview -pickplace insert
  clear_repeat $W
}

# j:tkb:eol W K A - move to end of line (ignores count)
proc j:tkb:eol { W K A } {
  $W mark set insert {insert lineend}
  $W yview -pickplace insert
  clear_repeat $W
}

# j:tkb:up W K A - move up
proc j:tkb:up { W K A } {
  global j_teb 

  for {set jri 0} {$jri < $j_teb(repeat_count,$W)} {incr jri} {
      if {[$W compare {insert - 1 line} >= {begin + 1 char}] == 1 } {
          $W mark set insert {insert - 1 line}
      } else {
        $W mark set insert {begin + 1 char}
        break
      }
  }
  $W yview -pickplace insert
  clear_repeat $W
}

# j:tkb:down W K A - move down
proc j:tkb:down { W K A } {
  j:tkb:repeatable {$W mark set insert {insert + 1 line}} $W
  $W yview -pickplace insert
}

# j:tkb:left W K A - move left
proc j:tkb:left { W K A } {
  j:tkb:repeatable { if {[$W index begin] != [$W index {insert - 1 char}]} {
      $W mark set insert {insert - 1 char}}} $W
  $W yview -pickplace insert
}

# j:tkb:right W K A - move right
proc j:tkb:right { W K A } {
  j:tkb:repeatable {$W mark set insert {insert + 1 char}} $W
  $W yview -pickplace insert
}

# j:tkb:bof W K A - move to beginning of file (widget)
proc j:tkb:bof { W K A } {
  j:tkb:repeatable {
    $W mark set insert 0.0
    $W yview -pickplace 0.0
  } $W
}

# j:tkb:eof W K A - move to end of file (widget)
proc j:tkb:eof { W K A } {
  j:tkb:repeatable {
    $W mark set insert end
    $W yview -pickplace end
  } $W
}

# j:tkb:word_left W K A - move back one word
proc j:tkb:word_left { W K A } {
  j:tkb:repeatable {
    while {[$W compare insert != {begin + 1 char}] &&
           [string match "\[ \t\n\]" [$W get {insert - 1 char}]]} {
      $W mark set insert {insert - 1 char}
    }
    while {[$W compare insert != {begin + 1 char}] &&
           ![string match "\[ \t\n\]" [$W get {insert - 1 char}]]} {
      $W mark set insert {insert - 1 char}
    }
    $W yview -pickplace insert
  } $W
}

# j:tkb:word_right W K A - move forward one word
proc j:tkb:word_right { W K A } {
  j:tkb:repeatable {
    while {[$W compare insert != end] &&
           [string match "\[ \t\n\]" [$W get insert]]} {
      $W mark set insert {insert + 1 char}
    }
    while {[$W compare insert != end] &&
           ![string match "\[ \t\n\]" [$W get insert]]} {
      $W mark set insert {insert + 1 char}
    }
    $W yview -pickplace insert
  } $W
}

######################################################################
###  TEXT DELETION COMMANDS
######################################################################

# j:tkb:kill_line W K A - delete this line (in insert mode)
# and return cursor to start of prompt

proc j:tkb:kill_line { W K A } {

    $W delete {begin + 1 char} end
    $W mark set insert {begin + 1 char} 
}

# j:tkb:delete_right W K A - delete character at insert
# use count to place deleted text in cutbuffer
proc j:tkb:delete_right { W K A } {

  global j_teb

  if [$W compare insert != end] {
    set j_teb(modified,$W) 1
  
    $W mark set del_from insert
    set cnt $j_teb(repeat_count,$W)
    $W mark set del_to "insert + $cnt char"

    set j_teb(cutbuffer,$W) [$W get del_from del_to]
    $W delete del_from del_to
  }
  clear_repeat $W
}

# j:tkb:delete_left W K A - delete character before insert
proc j:tkb:delete_left { W K A } {

  if {[$W compare insert != {begin + 1 char}]} {
    global j_teb
    set j_teb(modified,$W) 1
  
    j:tkb:repeatable {
      $W delete {insert - 1 char}
      $W yview -pickplace insert
    } $W
  }
}

#### FOLLOWING TWO SHOULD BE INTEGRATED WITH MOTION COMMANDS.
#### FOLLOWING TWO NEED TO HANDLE CUTBUFFER!

# j:tkb:delete_left_word W K A - move back one word
proc j:tkb:delete_left_word { W K A } {
  j:tkb:repeatable {
    $W mark set del_to insert
    while {[$W compare insert != {begin + 1 char}] &&
           [string match "\[ \t\n\]" [$W get {insert - 1 char}]]} {
      $W mark set insert {insert - 1 char}
    }
    while {[$W compare insert != {begin + 1 char}] &&
           ![string match "\[ \t\n\]" [$W get {insert - 1 char}]]} {
      $W mark set insert {insert - 1 char}
    }
    $W delete insert del_to
    $W yview -pickplace insert
  } $W
}

# j:tkb:delete_right_word W K A - move forward one word
proc j:tkb:delete_right_word { W K A } {
  j:tkb:repeatable {
    $W mark set del_from insert
    while {[$W compare insert != end] &&
           [string match "\[ \t\n\]" [$W get insert]]} {
      $W mark set insert {insert + 1 char}
    }
    while {[$W compare insert != end] &&
           ![string match "\[ \t\n\]" [$W get insert]]} {
      $W mark set insert {insert + 1 char}
    }
    $W delete del_from insert
    $W yview -pickplace insert
  } $W
}

######################################################################
###  TEXT UNDOING COMMANDS (and keyboard paste)
######################################################################

# j:tkb:put_text put text in cutbuffer at cursor location
proc j:tkb:put_text_right { W K A } {

  global j_teb

  if [$W compare insert != end] {
    $W mark set insert {insert + 1 char}
  }
  
  j:tkb:repeatable {
    global j_teb
    $W insert insert $j_teb(cutbuffer,$W)
  } $W

  $W yview -pickplace insert
}

####################################

j:tb:init				;# set up global variables

####################################
