/*****************************************************************************/
//	LogicalArrayArg.h
/*****************************************************************************/

#ifndef _LogicalArrayArg_H_
#define _LogicalArrayArg_H_

#include "ArrayArg.h"
#include "VersionedBindEnv.h"

/*****************************************************************************/

class corLogicalArrayArg : public corArrayArg {
	int _size;
	corVersionedBindEnv *corarray;
	// WARNING: Really ought to make a version of the VersionedBindEnv code
	// to deal with args rather than terms.	The current implementation
	// wastes some space.
public:
	// Optional methods
	corLogicalArrayArg(int size1);
	corLogicalArrayArg(int size1, corVersionedBindEnv *env);
	corArrayArg *make_version();
	virtual int size() {return _size;}

	virtual inline corCArg lookup(int i) const { 
		if( i < 0 || i >= _size)
			return NULL;
		else
			return (corarray->lookup(i).expr);
	}

	virtual inline int bind(int i, corCArg *arg) {
		// Physical bind!
		if( i < 0 || i > _size)
			return -1;
		else {
			corTerm term(*arg,NULL);
			corarray->bind(i,term);
			return 1;
		}
	}

	// Mandatory Methods
	virtual void print(corBindEnv *context, FILE *file) const;
	virtual void print(corBindEnv *context, FILE *file, char *) const {
		print(context, file) ;
	};
};

/*****************************************************************************/

extern char *corLogicalArrayConstructorString;
extern char *corLogicalArrayBindString;

/*****************************************************************************/

#endif _LogicalArrayArg_H_

