/*****************************************************************************/
//    BuiltinUtil.C
/*****************************************************************************/

#include <stdio.h>

#include "Globals.h"
#include "CoralError.h"

/*****************************************************************************/
int set_print_file(char *file_name)
{
    if ((corexEnv->print_file) && (corexEnv->print_file != stdout) &&
        (strcmp(corexEnv->print_filename, corexEnv->trace_filename)))
    {
        fclose(corexEnv->print_file);
        delete [] corexEnv->print_filename;
    }
        
    if (!strcmp(file_name, "stdout")) {
        corexEnv->print_file = stdout;
        corexEnv->print_filename = new char[7];
        strcpy(corexEnv->print_filename, "stdout");
    }
    else if (!strcmp(file_name, "stderr")) {
        corexEnv->print_file = stderr;
        corexEnv->print_filename = new char[7];
        strcpy(corexEnv->print_filename, "stderr");
    }
    else if (!strcmp(file_name, corexEnv->trace_filename)) {
        corexEnv->print_file = corexEnv->trace_file;
        corexEnv->print_filename = corexEnv->trace_filename;
    }
    else if (corexEnv->print_file = fopen(file_name, "a"))
        corexEnv->print_filename = file_name;
    else {
        corexEnv->print_file = stdout;
        corexEnv->print_filename = new char[7];
        strcpy(corexEnv->print_filename, "stdout");
        CORAL_error(COR_CANNOT_OPEN_FILE, file_name, "set_print_file",
            __FILE__, __LINE__);
        return 0;
    }
    return 1;
}

/*****************************************************************************/
int set_trace_file(char *file_name)
{
    if ((corexEnv->trace_file) && (corexEnv->trace_file != corexEnv->error_file) &&
        (strcmp(corexEnv->print_filename, corexEnv->trace_filename)))
    {
        fclose(corexEnv->trace_file);
        delete [] corexEnv->trace_filename;
    }
    
    if (!strcmp(file_name, "stdout")) {
        corexEnv->print_file = stdout;
        corexEnv->print_filename = new char[7];
        strcpy(corexEnv->print_filename, "stdout");
    }
    else if (!strcmp(file_name, "stderr")) {
        corexEnv->print_file = stderr;
        corexEnv->print_filename = new char[7];
        strcpy(corexEnv->print_filename, "stderr");
    }
    else if (!strcmp(file_name, corexEnv->error_filename)) {
        corexEnv->trace_file = corexEnv->error_file;
        corexEnv->trace_filename = new char[7];
        strcpy(corexEnv->trace_filename, corexEnv->error_filename);
    }
    else if (!strcmp(file_name, corexEnv->print_filename)) {
        corexEnv->trace_file = corexEnv->print_file;
        corexEnv->trace_filename = corexEnv->print_filename;
    }
    else if (corexEnv->trace_file = fopen(file_name, "a"))
        corexEnv->trace_filename = file_name ;
    else {
        corexEnv->trace_file = corexEnv->error_file;
        corexEnv->trace_filename = new char[7];
        strcpy(corexEnv->trace_filename, "exEnv->error_file");
        CORAL_error(COR_CANNOT_OPEN_FILE, file_name, "set_trace_file",
            __FILE__, __LINE__ );
        return 0;
    }
    return 1;
}

/*****************************************************************************/
/*
    Executes the magic program using the system() call. The input file
    to magic is <infile_name>, and the output is <outfile_name>.M
*/

int corcallMagic(char *infile_name, char* outfile_name)
{
    char term_str[1000];

    sprintf(term_str, "cat %s | magic > %s.M", infile_name, outfile_name);

    if (system(term_str)) return(0);
    
    return(1);
}

/*****************************************************************************/
/*
    Executes the exist program using the system() call. The input file
    to exist is <infile_name>, and the output is <outfile_name>.E
*/

int corcallEQO(char *infile_name, char* outfile_name)
{
    char term_str[1000];

    sprintf(term_str, "cat %s | exist > %s.E", infile_name, outfile_name);

    if (system(term_str)) return(0);
    
    return(1);
}

/*****************************************************************************/
int cortableFile(const char* name)
{
    int l = strlen(name);

    if(name[l-2] == '.' && name[l-1] == 'T') {
        // '.T' specifies a table file
        return 1;
    }
    return 0;
}

/*****************************************************************************/
//    Files ending in .S, .C and .o are to be incrementally loaded

int corincrLoadFile(const char* name)
{
    int l = strlen(name);

    if (name[l-2] == '.' &&
        ((name[l-1] == 'S') || (name[l-1] == 'C') || (name[l-1] == 'o')))
    {
        return 1;
    }
    return 0;
}

/*****************************************************************************/

