/*****************************************************************************/
//    History.C
/*****************************************************************************/

#include "History.h"

#include "Config.h"

/*****************************************************************************/
corHistory::corHistory(int size)
{
    commands = new char* [size];
    counts = new int [size];
    for (int i = 0; i < size; i++) {
        commands[i] = NULL;
        counts[i] = 0;
    }
    array_size = size;
    cur_pos = 0;
}

/*****************************************************************************/
corHistory::corHistory()
{
    array_size = MAX_HISTORY_DEPTH;
    commands = new char* [array_size];
    counts = new int [array_size];
    for (int i = 0; i < array_size; i++) {
        commands[i] = NULL;
        counts[i] = 0;
    }
    cur_pos = 0;
}

/*****************************************************************************/
void corHistory::addCommand(char *newcommand, int current_count)
{
    if (commands[cur_pos]) delete (commands[cur_pos]);

    commands[cur_pos] = new char[strlen(newcommand) + 1];
    strcpy(commands[cur_pos], newcommand);
    counts[cur_pos] = current_count;
    if ((++cur_pos) >= array_size) cur_pos    = 0;
}

/*****************************************************************************/
char * corHistory::getCommand(int desired_count)
{
    for (int i = 0; i < array_size; i++) {
        if (counts[i] == desired_count)
            return commands[i];
    }
    return NULL;
}

/*****************************************************************************/
void corHistory::display(FILE *outf)
{
    int i;

    fprintf(outf, "    Command History\n");
    for (i = cur_pos; i < array_size; i++) {
        if (commands[i])
            fprintf(outf, "    %d : %s\n", counts[i], commands[i]);
    }
    for (i = 0; i < cur_pos; i++) {
        if (commands[i])
            fprintf(outf, "    %d : %s\n", counts[i], commands[i]);
    }
    fprintf(outf, "\n");
}

/*****************************************************************************/

