// *************************************************************************
//    Array.C
// *************************************************************************

#include "Array.h"

#include <stdlib.h>

// *************************************************************************
//    add element x to array a 

void coradd_to_array(struct corarray *a, int x)
{
    if (a->length >= a->data_size) {
        if (a->data_size == 0) {
            a->data_size = 32;
            a->data = new int[a->data_size];
        }
        else {
            int i, len, *tmp_array;
            a->data_size += a->data_size;
            tmp_array = a->data;
            a->data = new int[a->data_size];
            len = a->length;
            for (i=0; i<len; i++)
                (a->data)[i] = tmp_array[i];
            delete [] tmp_array;
        }
    }
    a->data[a->length++] = x;
}

// *************************************************************************
//    copies contents of array arr2 to array arr1

void corcopy_array(struct corarray& arr1, struct corarray& arr2)
{
    int free_it = 1;

    if (arr1.data == arr2.data){
        free_it = 0;
        // This routine must defend itself, the higher two structures
        // can both have a pointer to the same array.
    } 

    arr1.length = arr2.length;
    arr1.data_size = arr2.data_size;
    if (arr1.data && free_it)
        delete [] arr1.data;
    arr1.data = new int[arr1.data_size];
    for (int i=0; i < arr1.length; i++)
        arr1.data[i] = arr2.data[i];
}


// *************************************************************************

void corCArgDynArray::add(corCArg* x)
{
    if (length >= data_size) {
        if (data_size == 0) {
            data_size = 32;
            data = new (corCArg *)[data_size];
        }
        else {
            int len = data_size;
            data_size += data_size;
            corCArg **tmp_data = data;
            data = new (corCArg*)[data_size];
            for (int i=0; i<len; i++)
                data[i] = tmp_data[i];
            delete [] tmp_data;
        }
    }
    data[length++] = x;
}

// *************************************************************************
//    copies contents of array arr2 to me

void corCArgDynArray::copy(corCArgDynArray& arr2)
{
    length = arr2.length;
    data_size = arr2.data_size;
    data = new (corCArg *)[data_size];
    for (int i = 0; i < length; i++)
        data[i] = arr2.data[i];
}

// *************************************************************************
