// *************************************************************************
//    Table.C
// *************************************************************************

#include "Table.h"

#include "QFModuleData.h"

// *************************************************************************
void corTable::AddValue(int i, Name relName, int arity)
{
    rels[i].AssignVal(relName, arity);
}

// *************************************************************************
corTable::corTable(corQFModuleData *md)
{
    corTable *F = md->F;

    numRels = F->numRels ;
    rels = new corRelationStruct[numRels];
    for (int i = 0; i< numRels; i++)
        rels[i].AssignVal(F->rels[i].relName, F->rels[i].relArity);
    next = NULL;
    context = NULL;
    moduledata = md;
    module_env = new corModuleEnv((corQFMaterializedModuleData *)md);
}

// *************************************************************************
corTable::~corTable()
{
    if (rels)
        delete [] rels;
    if (module_env)
        delete module_env;
}

// *************************************************************************

