/*****************************************************************************/
//    Scc.C
/*****************************************************************************/

#include <stdio.h>
#include "Predicate.h"
#include "Unparse.h"

/*****************************************************************************/
void corScc::print(FILE* fd, int print_preds, int print_rules)
{ 
  corPredicate *p_list;
  int ruleno = 0;
  corClause *clause;

  if (print_preds) {
    fprintf(fd, "  predicates: ");

    // print all predicate name in the Scc
    p_list = preds;
    while (p_list != NULL) 
      { 
    fprintf(fd, "%s", p_list->name->str);
    if (p_list->ext_magic)
      fprintf(fd, "(ext_magic)");
    p_list = p_list->next;
    if (p_list != NULL)
      fprintf(fd, ", ");
      }
    fprintf(fd, "\n");
  }
  
  if (print_rules) {
    p_list = preds;
    while (p_list != NULL)
      { 
    for (clause = p_list->clauses; clause; clause = clause->pnext) {
      fprintf(fd, "  rule #%d: ", ruleno++);
      corprint_rule(clause, fd);
    }
    p_list = p_list->next;

      }
  } 
      
}
