/*****************************************************************************/
//    BPlusTreeIndex.h
/*****************************************************************************/

#ifndef _BPlusTreeIndex_H_
#define _BPlusTreeIndex_H_

#include "IndexStruct.h"
#include "Config.h"

/*****************************************************************************/

class corBPlusTreeIndex : public corIndexStruct {
public:
    IID    iid;                            // Index id
    char attrs[COR_MAX_ARGLIST_SIZE];    // Specifies which attributes the index
                    // is on. A non-zero value of an entry
                    // implies that the index is based on
                    // the corresponding attribute of the
                    // relation

    virtual void operator=(corBPlusTreeIndex& index2)
    {
        for (int i = 0; i < COR_MAX_ARGLIST_SIZE; i++ )
            attrs[i] = index2.attrs[i];
        iid = index2.iid;
        arity = index2.arity;
    }

    virtual PersIndexKind kindof() { return COR_BPLUSTREE; };
    virtual int    valid() { return !(IID_IS_INVALID(iid));};
    corBPlusTreeIndex();
    virtual void create(corBitVector *, int arity, int unique);
    virtual void insert(USERDESC *u_desc, corSchema&);
    virtual int matches(char *attr_str, int arity);
    virtual void delete_entry(USERDESC *u_desc, corSchema&);
    virtual void destroy();
    virtual void corprint_adornment(FILE *outf);
    virtual int begin_load();
    virtual int end_load();
    virtual int abort_load();
};

/*****************************************************************************/

#endif _BPlusTreeIndex_H_

