//**************************************************************************
//    start_explain.C
//
//    A simple program to hook up to the coral server, and then run the
//    Explain tcl GUI.
//
//    This program expects its initial input from a pipe hooked to stdin.
//
//**************************************************************************

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <sys/param.h>

    // This is a hack, but otherwise entire coral library is compiled in.
#define   _NO_CORAL
#include "CoralSock.C"


//**************************************************************************

void die()
{
    fputs("\nCould not obtain start up info from stdin, exiting.\n\n",stderr);
    exit(1);
}

//**************************************************************************

int main(int argc, char **argv)
{
    int stat, pid;
    char server[HOSTNAME_LENGTH], password[10], buff[500];
    int conn_id, user_id;
    unsigned short port;

    if (argc < 3)
        die();
    strcpy(server,argv[1]);
    sscanf(argv[2],"%hu", &port);

      // Get info from stdin (will be a pipe)
    if (!fgets(buff, 500, stdin))
        die();
    sscanf(buff,"%d %d", &conn_id, &user_id);

    if (!fgets(password, 10, stdin))
        die();

//    fprintf(stdout, "Server: %s  Port: %hu\n", server, port);
//    fprintf(stdout, "Password: '%s'  Connection: (%d,%d)\n",password,
//        conn_id, user_id);

      // Must detach from the process that spawned us
    if ((pid = fork()) < 0){
        die();
    } else if (pid > 0){
          // parent must return so that tkcoral continues.
        return(0);
    }

      // Open a port to recieve explain info
    CoralSock *sock = new CoralSock(server, port);

    if (! sock->Valid()) {
        fprintf(stderr,"Explain: Couldn't connect to coral server (%s,%hu).\n",
            server, port);
        return(1);
    }

      // Tell coral server the connection id, user id, and password
    sprintf(buff,"%d %d %s", conn_id, user_id, password);
    write(sock->socketfd, buff, strlen(buff));

    dup2(sock->socketfd,0);
    //dup2(sock->socketfd,1);

      // Now start up the Explain tcl GUI and hook it in.

    char *croot = getenv("CORALROOT");
    if (!croot){
        fputs("You must set the envirornment variable CORALROOT.\n",stderr);
        return(1);
    }

    if ((pid = fork()) < 0){
        fprintf(stderr,"start_explain: Can't fork\n");
        return(1);
    }

    if (pid == 0){
            // child
        char *path = new char[MAXPATHLEN];
        char *path2 = new char[MAXPATHLEN];

        sprintf(path,"%s/bin/coralsh",croot);
        sprintf(path2,"%s/bin/Explain",croot);

        execl(path, "coralsh", "-f", path2, (char *) 0);
          // NOTREACHED
        delete [] path;
        delete [] path2;
        return(0);
    } else {
          // Hang around so coral server doesn't hang up
        wait(&stat);
    }

    delete sock;
    return(0);
}

//**************************************************************************
