/*****************************************************************************/
//    TermGArray.h
/*****************************************************************************/

#ifndef _TermGArray_H_
#define _TermGArray_H_

#include "Assert.h"
#include "Term.h"
#include "ObjectCount.h"

/*****************************************************************************/

class corTerm_garray {
    corTerm **tarray;
    int size;        
    int _limit;        
    int incr;         

public:    
    corTerm_garray(int size =128*128, int incr = 128, int tlimit=-1);

    inline corTerm& operator[](int i)
    {
        ASSERT(tarray!=NULL && i<_limit && i >= 0);
        if (i >= size) resize(2*size);            
        if (! tarray[i/incr]) {                 
            tarray[i/incr] = new corTerm[incr];    
            corC_NewGArraySize += incr*sizeof(corTerm);
        }                
        return ( tarray[i/incr][i%incr] );
    }                        
    int limit() {return _limit;}        
    int resize(int newsize);
    corTerm_garray *make_copy();
    int get_next(int i);
    ~corTerm_garray();
};

/*****************************************************************************/

#endif _TermGArray_H_

