/*****************************************************************************/
//	TupleIterator.C
/*****************************************************************************/

#include "TupleIterator.h"

/*****************************************************************************/
corTupleIterator::corTupleIterator(corRelation	*rel, corTuple *tuple,
    corRMark *start, corRMark *end)
	: arg_list(tuple->args()), temp_arglist(tuple->args())
{
	//if (relation = rel) relation->scan_count++;
	relation = rel;
	bindenv = tuple->make_bindenv_version();
	start_mark = start;
	end_mark = end;
	indexnump = NULL;
	reset();
}

/*****************************************************************************/
corTupleIterator::corTupleIterator(corRelation	*rel, corArgList& args,
     corBindEnv* env, corRMark *start, corRMark *end, int *tryindexp)
	: arg_list(args), temp_arglist(args)
{
	//if (relation = rel) relation->scan_count++;
	relation = rel;
	bindenv = env;
	start_mark = start;
	end_mark = end;
	indexnump = tryindexp;
	reset();
}

/*
TupleIterator::TupleIterator(Relation	*rel, Arg** args, BindEnv* env,
	RMark *start, RMark *end, int *tryindexp)
	: arg_list(*(ArgList*)args), temp_arglist(*(ArgList*)args)
{
	//if (relation = rel) relation->scan_count++;
	relation = rel;
	bindenv = env;
	start_mark = start;
	end_mark = end;
	indexnump = tryindexp;
	reset();
}
*/


corTupleIterator::~corTupleIterator()
{
	this->release();
	//if (relation)
	  //relation->release(*this);
	// if (tuple_env) 		// Check if code is safe and reinsert it
	// delete tuple_env;
}

/*****************************************************************************/
corBindEnv	*corTupleIterator::get_next()
{
	corBindEnv *temp = relation->get_next(*this);
	while (_no_match && state) {
		_no_match = 0;
		(*state->solver)(state->md, state->magic, 0, this);
		temp = relation->get_next(*this);
	}
	return temp;
}

/*****************************************************************************/

