/*****************************************************************************/
//	SupMagic.h
/*****************************************************************************/

#ifndef _SupMagic_H_
#define _SupMagic_H_

#include "Collection.h"
#include "Rule.h"
#include "SymbolArg.h"
#include "Literal.h"

/*****************************************************************************/

void supmagic(struct corcollection *ad_rules, struct corcollection *magic_rules);
void do_supp_magic_on_rule(corClause *adrule, struct corcollection *magic_rules);

void make_new_rule_vars(corClause *, int);
corVarArg* new_rule_var(corClause *, int);
corVarArg* make_supindex_var(corClause *adrule, int varnum, char letter = 'I');

Name new_pred_name(Name name);
Name new_pred_name(char *name);
Name new_interface_pred_name(char *name);

corLiteral* build_magic_pred(corClause *adrule, corLiteral * pred,
	int use_share_opt, int argnum = 0);
corLiteral* build_interface_magic_pred(corClause *adrule, corLiteral * pred,
	int use_share_opt, int argnum);

int count_bound_functor_args(corLiteral *head);
corLiteral* make_functor_literal(corClause *newrule, corLiteral *head, int argnum,
	int newvarnum);
void create_functor_literals(corClause *);
corLiteral* build_head_pred(corClause *newrule, corLiteral *oldhead);

void create_supmagic_index(corLiteral *pred);
void create_interface_index(corLiteral *pred);

corLiteral* make_vararglist_literal(corClause *rule, Name name, int startvarnum,
	int arity);
corLiteral* make_vararglist_literal(corClause *rule, char *name,
	int startvarnum, int arity);

void add_interface_rules(struct corcollection *magic_rules, Name predname,
	corBitVector &adorn);
void add_interface_rules(struct corcollection *magic_rules, char * predname,
	corBitVector &adorn);

/*****************************************************************************/

#endif _SupMagic_H_

