/*****************************************************************************/
//	SupOpt.C
/*****************************************************************************/

#include "SupOpt.h"

#include "SupMagic.h"

#include "Rule.h"
#include "Literal.h"

/*****************************************************************************/

extern int opt_share_functors;

/*****************************************************************************/
/*
	Perform a simple optimization to the supplementary magic rules: replace
	all occurrences of supmagic_r_1 by the right-hand side of the rule defining
	supmagic_r_1 and delete that rule.
*/

void supopt()
{
	int i;
	corLiteral* pred;
	corLiteral* newpred;
	Link**	ruleptr;
	extern struct corcollection magic_rules[1];	// Main.C

	for (ruleptr = &magic_rules->chain; *ruleptr;) {
		corClause *magicrule = (corClause*)*ruleptr;
		//	Delete any rule defining supmagic_r_1.
		if (magicrule->head->kind == COR_SUPMAGIC && magicrule->head->pos == 1)
		{
#			if 1
				*ruleptr = magicrule->link.next;
#			else
				remove_rule(magicrule, magic_rules);
#			endif
			free (magicrule);
			continue;
		}
		else {
			//	Search for and replace uses of supmagic_r_1.
			for (i=0; i < magicrule->num_preds; ++i) {
				pred = magicrule->preds[i];
				if (pred->kind == COR_SUPMAGIC && pred->pos == 1) {
					//	?Change the following to deal with opt_share_functors.
					newpred = build_magic_pred(NULL, pred->rule->head,0);
					magicrule->preds[i] = newpred;
					newpred->pred = pred->rule->head->pred;
					newpred->adorn = pred->rule->head->adorn;
				}
			}
		}
		ruleptr = &ruleptr[0]->next;
	}
}

/*****************************************************************************/

